package com.gic.haoban.manage.service.service.impl;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.dto.PreDealLogInfoDTO;
import com.gic.haoban.manage.api.dto.SyncCheckDTO;
import com.gic.haoban.manage.api.enums.PreDealStatusEnum;
import com.gic.haoban.manage.api.enums.PreDealTypeEnum;
import com.gic.haoban.manage.service.dao.mapper.PreDealLogMapper;
import com.gic.haoban.manage.service.entity.TabHaobanPreDealLog;
import com.gic.haoban.manage.service.service.PreDealService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created 2020/4/9.
 *
 * @author hua
 */
@Service
public class PreDealServiceImpl implements PreDealService {

    @Autowired
    private PreDealLogMapper preDealLogMapper;

    @Override
    public boolean insert(List<TabHaobanPreDealLog> list) {
        if (CollectionUtils.isEmpty(list)) {
            return true;
        }
        preDealLogMapper.insertSelectiveBatch(list);
        return true;
    }

    @Override
    public TabHaobanPreDealLog getByDataId(String taskId, String dataId,int dataType, int status) {
        List<TabHaobanPreDealLog> list = preDealLogMapper.getByDataId(taskId, dataId,dataType, status);
        if (CollectionUtils.isEmpty(list)) {
            return null;
        } else {
            return list.get(0);
        }
    }

    @Override
    public List<TabHaobanPreDealLog> listByPDataId(String taskId, String pDataId, int status) {
        return preDealLogMapper.listByPDataId(taskId, pDataId, status, PreDealTypeEnum.group.getVal());
    }

    @Override
    public List<TabHaobanPreDealLog> listReByPDataId(String taskId, String pDataId) {
        return preDealLogMapper.listReByPDataId(taskId, pDataId, PreDealTypeEnum.group.getVal());
    }

    @Override
    public boolean updateStatusByDataId(String taskId, String dataId, int status, String reason) {
        int i = preDealLogMapper.updateStatusByDataId(taskId, dataId,-1, status, reason);
        return i >= 0;
    }

    @Override
    public boolean updateStatusByDataId(String taskId, String dataId, int dataType, int status, String reason) {
        int i = preDealLogMapper.updateStatusByDataId(taskId, dataId,dataType, status, reason);
        return i >= 0;
    }

    @Override
    public boolean checkTask(String taskId, int dataType) {
        int i = preDealLogMapper.checkTask(taskId, dataType, PreDealStatusEnum.pre.getVal());
        return i == 0;
    }

    @Override
    public List<TabHaobanPreDealLog> listByTaskId(String taskId, int dataType, int status) {
        return preDealLogMapper.listByTaskId(taskId, dataType, status);
    }

    @Override
    public int countByTaskId(String taskId, int dataType, int status) {
        return preDealLogMapper.countByTaskId(taskId, dataType, status);
    }

    @Override
    public int countExcepAndPreByTaskId(String taskId, int dataType) {
        return preDealLogMapper.countExcepAndPreByTaskId(taskId, dataType);
    }

    @Override
    public List<TabHaobanPreDealLog> queryDepartRebuildDealLog(String taskId) {
        return preDealLogMapper.listRebuildDepartByTaskId(taskId);
    }

    @Override
    public List<TabHaobanPreDealLog> listRebuildByTaskId(String taskId, int dataType) {
        return preDealLogMapper.listRebuildByTaskId(taskId, dataType);
    }

    @Override
    public boolean updateExceptionToPre(String taskId) {
        int i = preDealLogMapper.updateExceptionToPre(taskId);
        return i >= 0;
    }

    @Override
    public Page<PreDealLogInfoDTO> listExceptionByTaskId(String taskId, BasePageInfo pageInfo) {
        PageHelper.startPage(pageInfo);
        List<TabHaobanPreDealLog> page = preDealLogMapper.listExceptionByTask(taskId);
        Page<PreDealLogInfoDTO> retPage = PageUtil.changePageHelperToCurrentPage(new PageInfo<>(page), PreDealLogInfoDTO.class);
        return retPage;
    }

    @Override
    public boolean existDataId(String taskId, String dataId) {
        int i = preDealLogMapper.countByDataId(taskId, dataId,PreDealTypeEnum.clerk.getVal());
        return i > 0;
    }
}
