import com.alibaba.fastjson.JSONObject;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.dto.SyncSingleDealDTO;
import com.gic.haoban.manage.api.service.DealSyncOperationApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.service.service.StaffService;
import com.gic.haoban.manage.service.service.TestService;
import com.gic.redis.data.util.RedisUtil;
import com.gic.wechat.api.dto.qywx.QywxExternalcontactDTO;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.redisson.api.RLock;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {"classpath:applicationContext-conf.xml"})
public class DealSyncTest {

    private static Logger logger= LoggerFactory.getLogger(DealSyncTest.class);

    @Autowired
    private DealSyncOperationApiService dealSyncOperationApiService;

    @Autowired
    private StaffApiService staffApiService;

    @Autowired
    private StaffService staffService;

    @Autowired
    private QywxUserApiService qywxUserApiService;

    @Autowired
    private TestService testService;

    @Test
    public void test() {
        List<SyncSingleDealDTO> add = new ArrayList<>();
        List<SyncSingleDealDTO> edit = new ArrayList<>();

        {
            SyncSingleDealDTO dealDTO = new SyncSingleDealDTO();
            dealDTO.setDepartmentId("ff80808166c3a1050166c43175d9000e");
            dealDTO.setParentDepartmentId("a101b3a51cd549e79f3daec1aa628301");
            dealDTO.setDepartmentName("西溪花园");
            dealDTO.setRelatedId("ff80808166c3a1050166c43175d9000e");
            dealDTO.setStoreFlag(0);
            dealDTO.setEnterpriseId("ff8080815dacd3a2015dacd3ef5c0000");
            add.add(dealDTO);
        }

        {
            SyncSingleDealDTO dealDTO = new SyncSingleDealDTO();
            dealDTO.setDepartmentId("100333808083");
            dealDTO.setParentDepartmentId("a101b3a51cd549e79f3daec1aa628301");
            dealDTO.setDepartmentName("测试门店1003338");
            dealDTO.setRelatedId("100333808083");
            dealDTO.setStoreFlag(1);
            dealDTO.setEnterpriseId("ff8080815dacd3a2015dacd3ef5c0000");
            add.add(dealDTO);
        }
        dealSyncOperationApiService.dealQywxDepartment("111", "ca66a01b79474c40b3e7c7f93daf1a3b");
    }

    @Test
    public void test2() {
        int i =1;
        while (true) {
            i++;
            if (i==5){
                System.out.println("close");
                RedisUtil.close();
            }
            if (i==10||i==25){
                System.out.println("creConnect");
                RedisUtil.reConnect();
            }
            try {
                RedisUtil.setCache("1", "2");
                Object cache = RedisUtil.getCache("1");
                System.out.println("======={}"+i+":"+cache);
                Thread.sleep(2000);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Test
    public void test3() {
        staffApiService.getWxSaveNew("3e7a7c09097a40b18aef1478b04688fe", "ca66a01b79474c40b3e7c7f93daf1a3b");
    }

    @Test
    public void test5() {
        String key="test2";
        RedisUtil.lock(key,100L, TimeUnit.SECONDS,0L);
//        try {
//            Thread.sleep(3000);
//        } catch (InterruptedException e) {
//            e.printStackTrace();
//        }
//        if(RedisUtil.isLocked(key)){
//            RedisUtil.unlock(key);
//        }
    }

    @Test
    public void test6() {
        String key="test2";
//        RedisUtil.lock(key,100L, TimeUnit.SECONDS,0L);
//        try {
//            Thread.sleep(3000);
//        } catch (InterruptedException e) {
//            e.printStackTrace();
//        }
        RLock lock = RedisUtil.getRedisClient().getLock(key);
        try {
            if (lock.tryLock(0, 10, TimeUnit.MINUTES)) {
                try {
                    Thread.sleep(1000L);
                } finally {
                    lock.unlock();
                }
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
//        if(RedisUtil.isLocked(key)){
//            RedisUtil.unlock(key);
//        }
//        RedisUtil.unlock();
//        RedisUtil.setCache("test5511","111",2592030L);
    }

    @Test
    public void test4() {
        List<StaffDTO> retList = staffService.listByUserIdsAndWxEnterpriseId(null, "ca66a01b79474c40b3e7c7f93daf1a3b");
        System.out.println(retList.size());

        if (CollectionUtils.isEmpty(retList)) {
            return;
        }
        List<StaffDTO> staffDTOS = retList.subList(2, retList.size()-1);
        staffDTOS.forEach(staffDTO -> {
            if (StringUtils.isNotBlank(staffDTO.getWxUserId())) {
                logger.info(staffDTO.getWxUserId());
                QywxExternalcontactDTO send = new QywxExternalcontactDTO();
                send.setType(1);
                send.setScene(1);
                send.setRemark("tesst_" + staffDTO.getPhoneNumber());
                List<String> userIds = new ArrayList<>();
                userIds.add(staffDTO.getWxUserId());
                send.setUser(userIds);
                String configId = qywxUserApiService.getExternalcontactByUserId("ww9ede832a84b7ae5f", "65zze159pYb4ofbFsIREZ5X7d7iaZ-bWsVIQk2y5kTU", send);
                if (StringUtils.isNotBlank(configId)) {
                    logger.info("staff:{}", configId, JSONObject.toJSONString(staffDTO));
                    com.gic.haoban.manage.service.entity.Test test = new com.gic.haoban.manage.service.entity.Test();
                    test.setId(configId);
                    test.setName(staffDTO.getWxUserId());
                    testService.save(test);
                }
            }
        });

    }
}
